wagtailvideos/urls.py
from django.urls import path, re_path

from wagtailvideos.views import chooser, multiple, videos

app_name = 'wagtailvideos'
urlpatterns = [
    path('add/', videos.add, name='add'),
    re_path(r'^usage/(\d+)/$', videos.usage, name='video_usage'),

    path('multiple/add/', multiple.add, name='add_multiple'),
    re_path(r'^multiple/(\d+)/delete/$', multiple.delete, name='delete_multiple'),
    re_path(r'^multiple/(\d+)/$', multiple.edit, name='edit_multiple'),

    path('chooser/upload/', chooser.chooser_upload, name='chooser_upload'),
    re_path(r'^chooser/(\d+)/$', chooser.video_chosen, name='video_chosen'),
    path('chooser/', chooser.chooser, name='chooser'),

    re_path(r'^(\d+)/delete/$', videos.delete, name='delete'),
    re_path(r'^(\d+)/create_transcode/$', videos.create_transcode, name='create_transcode'),
    re_path(r'^(\d+)/$', videos.edit, name='edit'),
    path('', videos.index, name='index'),
]

wagtailvideos/forms.py
from django import forms
from django.forms.models import modelform_factory
from django.utils.translation import gettext as _
from enumchoicefield.forms import EnumField
from wagtail.admin import widgets
from wagtail.admin.forms.collections import (
    BaseCollectionMemberForm, collection_member_permission_formset_factory)

from wagtailvideos.fields import WagtailVideoField
from wagtailvideos.models import MediaFormats, Video, VideoQuality
from wagtailvideos.permissions import \
    permission_policy as video_permission_policy


class BaseVideoForm(BaseCollectionMemberForm):
    permission_policy = video_permission_policy

    def __init__(self, *args, **kwargs):
        super(BaseVideoForm, self).__init__(*args, **kwargs)
        # A file is only required if there is not already a file, such as when
        # editing an existing video.  The file field is not used on the
        # multiple-upload forms, so may not be present
        if 'file' in self.fields:
            self.fields['file'].required = 'file' not in self.initial or not self.initial['file']


# Callback to allow us to override the default form field for the video file field
def formfield_for_dbfield(db_field, **kwargs):
    # Check if this is the file field
    if db_field.name == 'file':
        return WagtailVideoField(**kwargs)

    # For all other fields, just call its formfield() method.
    return db_field.formfield(**kwargs)


def get_video_form(model):
    fields = model.admin_form_fields
    if 'collection' not in fields:
        # force addition of the 'collection' field, because leaving it out can
        # cause dubious results when multiple collections exist (e.g adding the
        # document to the root collection where the user may not have permission) -
        # and when only one collection exists, it will get hidden anyway.
        fields = list(fields) + ['collection']

    return modelform_factory(
        model,
        form=BaseVideoForm,
        fields=fields,
        formfield_callback=formfield_for_dbfield,
        # set the 'file' widget to a FileInput rather than the default ClearableFileInput
        # so that when editing, we don't get the 'currently: ...' banner which is
        # a bit pointless here
        widgets={
            'tags': widgets.AdminTagWidget,
            'file': forms.FileInput(),
            'thumbnail': forms.FileInput(),
        })


class VideoTranscodeAdminForm(forms.Form):
    media_format = EnumField(MediaFormats)
    quality = EnumField(VideoQuality)

    def __init__(self, video, data=None, **kwargs):
        super(VideoTranscodeAdminForm, self).__init__(data=data, **kwargs)
        self.video = video

    def save(self):
        media_format = self.cleaned_data['media_format']
        quality = self.cleaned_data['quality']
        self.video.do_transcode(media_format, quality)


GroupVideoPermissionFormSet = collection_member_permission_formset_factory(
    Video,
    [
        ('add_video', _("Add"), _("Add/edit videos you own")),
        ('change_video', _("Edit"), _("Edit any video")),
    ],
    'wagtailvideos/permissions/includes/video_permissions_formset.html'
)

wagtailvideos/views/chooser.py
from distutils.version import LooseVersion

import wagtail
from django.core.paginator import Paginator
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from django.utils.translation import gettext as _
from wagtail.admin.forms.search import SearchForm
from wagtail.admin.modal_workflow import render_modal_workflow
from wagtail.core.models import Collection
from wagtail.search import index as search_index

from wagtailvideos import get_video_model
from wagtailvideos.forms import get_video_form
from wagtailvideos.permissions import permission_policy

if LooseVersion(wagtail.__version__) >= LooseVersion('2.7'):
    from wagtail.admin.auth import PermissionPolicyChecker
    from wagtail.admin.models import popular_tags_for_model
else:
    from wagtail.admin.utils import (
        PermissionPolicyChecker, popular_tags_for_model)

permission_checker = PermissionPolicyChecker(permission_policy)


def get_chooser_js_data():
    """construct context variables needed by the chooser JS"""
    return {
        'step': 'chooser',
        'error_label': _("Server Error"),
        'error_message': _("Report this error to your webmaster with the following information:"),
        'tag_autocomplete_url': reverse('wagtailadmin_tag_autocomplete'),
    }


def get_video_json(video):
    """
    helper function: given a video, return the json to pass back to the
    video chooser panel
    """

    return {
        'id': video.id,
        'edit_link': reverse('wagtailvideos:edit', args=(video.id,)),
        'title': video.title,
        'preview': {
            'url': video.thumbnail.url if video.thumbnail else '',
        }
    }


def chooser(request):
    Video = get_video_model()
    VideoForm = get_video_form(Video)
    uploadform = VideoForm()

    videos = Video.objects.order_by('-created_at')

    q = None
    if (
        'q' in request.GET or 'p' in request.GET or 'tag' in request.GET
        or 'collection_id' in request.GET
    ):
        # this request is triggered from search, pagination or 'popular tags';
        # we will just render the results.html fragment
        collection_id = request.GET.get('collection_id')
        if collection_id:
            videos = videos.filter(collection=collection_id)

        searchform = SearchForm(request.GET)
        if searchform.is_valid():
            q = searchform.cleaned_data['q']

            videos = videos.search(q)
            is_searching = True
        else:
            is_searching = False

            tag_name = request.GET.get('tag')
            if tag_name:
                videos = videos.filter(tags__name=tag_name)

        # Pagination
        paginator = Paginator(videos, per_page=12)
        page = paginator.get_page(request.GET.get('p'))

        return render(request, "wagtailvideos/chooser/results.html", {
            'videos': page,
            'is_searching': is_searching,
            'query_string': q,
        })
    else:
        searchform = SearchForm()

        collections = Collection.objects.all()
        if len(collections) < 2:
            collections = None

        paginator = Paginator(videos, per_page=12)
        page = paginator.get_page(request.GET.get('p'))

    return render_modal_workflow(request, 'wagtailvideos/chooser/chooser.html', None, {
        'videos': page,
        'uploadform': uploadform,
        'searchform': searchform,
        'is_searching': False,
        'query_string': q,
        'popular_tags': popular_tags_for_model(Video),
        'collections': collections,
    }, json_data=get_chooser_js_data())


def video_chosen(request, video_id):
    video = get_object_or_404(get_video_model(), id=video_id)

    return render_modal_workflow(
        request, None, json_data={
            'step': 'video_chosen',
            'result': get_video_json(video)
        })


@permission_checker.require('add')
def chooser_upload(request):
    Video = get_video_model()
    VideoForm = get_video_form(Video)

    searchform = SearchForm()

    if request.POST:
        video = Video(uploaded_by_user=request.user)
        form = VideoForm(request.POST, request.FILES, instance=video)

        if form.is_valid():
            video.uploaded_by_user = request.user
            video.save()

            # Reindex the video to make sure all tags are indexed
            search_index.insert_or_update_object(video)

            return render_modal_workflow(
                request, None, json_data={
                    'step': 'video_chosen',
                    'result': get_video_json(video)
                }
            )
    else:
        form = VideoForm()

    videos = Video.objects.order_by('title')
    paginator = Paginator(videos, per_page=12)
    page = paginator.get_page(request.GET.get('p'))

    return render_modal_workflow(
        request, 'wagtailvideos/chooser/chooser.html', None,
        template_vars={'videos': page, 'uploadform': form, 'searchform': searchform},
        json_data=get_chooser_js_data()
    )

wagtailvideos/views/multiple.py
from distutils.version import LooseVersion

import wagtail
from django.http import HttpResponseBadRequest, JsonResponse
from django.shortcuts import get_object_or_404, render
from django.template.loader import render_to_string
from django.utils.encoding import force_str
from django.views.decorators.http import require_POST
from django.views.decorators.vary import vary_on_headers
from wagtail.search.backends import get_search_backends

from wagtailvideos import get_video_model
from wagtailvideos.forms import get_video_form
from wagtailvideos.permissions import permission_policy

if LooseVersion(wagtail.__version__) >= LooseVersion('2.7'):
    from wagtail.admin.auth import PermissionPolicyChecker
else:
    from wagtail.admin.utils import PermissionPolicyChecker

permission_checker = PermissionPolicyChecker(permission_policy)


def get_video_edit_form(VideoModel):
    VideoForm = get_video_form(VideoModel)

    # Make a new form with the file and focal point fields excluded
    class VideoEditForm(VideoForm):
        class Meta(VideoForm.Meta):
            model = VideoModel
            exclude = (
                'file',
            )

    return VideoEditForm


@vary_on_headers('X-Requested-With')
def add(request):
    Video = get_video_model()
    VideoForm = get_video_form(Video)

    collections = permission_policy.collections_user_has_permission_for(request.user, 'add')
    if len(collections) > 1:
        collections_to_choose = collections
    else:
        # no need to show a collections chooser
        collections_to_choose = None

    if request.method == 'POST':
        if request.headers.get('x-requested-with') != 'XMLHttpRequest':
            return HttpResponseBadRequest("Cannot POST to this view without AJAX")

        if not request.FILES:
            return HttpResponseBadRequest("Must upload a file")

        # Build a form for validation
        form = VideoForm({
            'title': request.FILES['files[]'].name,
            'collection': request.POST.get('collection'),
        }, {
            'file': request.FILES['files[]'],
        })
        if form.is_valid():
            # Save
            video = form.save(commit=False)
            video.uploaded_by_user = request.user
            video.save()

            # Success! Send back an edit form
            return JsonResponse({
                'success': True,
                'video_id': int(video.id),
                'form': render_to_string('wagtailvideos/multiple/edit_form.html', {
                    'video': video,
                    'form': get_video_edit_form(Video)(
                        instance=video, prefix='video-%d' % video.id),
                }, request=request),
            })
        else:
            # Validation error
            return JsonResponse({
                'success': False,

                # https://github.com/django/django/blob/stable/1.6.x/django/forms/util.py#L45
                'error_message': '\n'.join(['\n'.join([force_str(i) for i in v]) for k, v in form.errors.items()]),
            })
    else:
        form = VideoForm()

    return render(request, 'wagtailvideos/multiple/add.html', {
        'max_filesize': form.fields['file'].max_upload_size,
        'help_text': form.fields['file'].help_text,
        'error_max_file_size': form.fields['file'].error_messages['file_too_large_unknown_size'],
        'error_accepted_file_types': form.fields['file'].error_messages['invalid_video_format'],
        'collections': collections_to_choose,
    })


@require_POST
def edit(request, video_id, callback=None):
    Video = get_video_model()
    VideoForm = get_video_edit_form(Video)

    video = get_object_or_404(Video, id=video_id)

    if request.headers.get('x-requested-with') != 'XMLHttpRequest':
        return HttpResponseBadRequest("Cannot POST to this view without AJAX")

    form = VideoForm(
        request.POST, request.FILES, instance=video, prefix='video-' + video_id
    )

    if form.is_valid():
        form.save()

        # Reindex the video to make sure all tags are indexed
        for backend in get_search_backends():
            backend.add(video)

        return JsonResponse({
            'success': True,
            'video_id': int(video_id),
        })
    else:
        return JsonResponse({
            'success': False,
            'video_id': int(video_id),
            'form': render_to_string('wagtailvideos/multiple/edit_form.html', {
                'video': video,
                'form': form,
            }, request=request),
        })


@require_POST
def delete(request, video_id):
    video = get_object_or_404(get_video_model(), id=video_id)

    if request.headers.get('x-requested-with') != 'XMLHttpRequest':
        return HttpResponseBadRequest("Cannot POST to this view without AJAX")

    video.delete()

    return JsonResponse({
        'success': True,
        'video_id': int(video_id),
    })

wagtailvideos/templates/wagtailvideos/videos/_file_field.html
{% extends "wagtailadmin/shared/field.html" %}
{% load i18n %}
{% block form_field %}
    <a href="{{ video.url }}" class="icon icon-media">{{ video.filename }}</a><br /><br />

    {% trans "Change video file:" %}
    {{ field }}
{% endblock %}

wagtailvideos/templates/wagtailvideos/videos/_file_field_as_li.html
{% load wagtailadmin_tags %}
<li class="{% if field.field.required %}required{% endif %} {{ wrapper_classes }} {{ li_classes }} {% if field.errors %}error{% endif %}">
    {% include "wagtailvideos/videos/_file_field.html" %}
</li>

wagtailvideos/templates/wagtailvideos/videos/add.html
{% extends "wagtailadmin/base.html" %}
{% load i18n %}
{% block titletag %}{% trans "Add a video" %}{% endblock %}

{% block extra_js %}
    {{ block.super }}

    {% url 'wagtailadmin_tag_autocomplete' as autocomplete_url %}
    <script>
        $(function() {
            $('#id_tags').tagit({
                autocomplete: {source: "{{ autocomplete_url|addslashes }}"}
            });
        });
    </script>
{% endblock %}

{% block content %}
    {% trans "Add video" as add_str %}
    {% include "wagtailadmin/shared/header.html" with title=add_str icon="media" %}

    <div class="nice-padding">
        <form action="{% url 'wagtailvideos:add' %}" method="POST" enctype="multipart/form-data">
            {% csrf_token %}
            <ul class="fields">
                {% for field in form %}
                    {% if field.is_hidden %}
                        {{ field }}
                    {% else %}
                        {% include "wagtailadmin/shared/field_as_li.html" with field=field %}
                    {% endif %}
                {% endfor %}
                <li><input class="button" type="submit" value="{% trans 'Save' %}" /></li>
            </ul>
        </form>
    </div>
{% endblock %}

wagtailvideos/templates/wagtailvideos/videos/confirm_delete.html
{% extends "wagtailadmin/base.html" %}
{% load wagtailvideos_tags %}
{% load i18n %}
{% block titletag %}{% trans "Delete video" %}{% endblock %}

{% block content %}
    {% trans "Delete video" as del_str %}
    {% include "wagtailadmin/shared/header.html" with title=del_str icon="media" %}

    <div class="row row-flush nice-padding">
        <div class="col6">
            {% video video controls style=max-width:100% %}
        </div>
        <div class="col6">
            <p>{% trans "Are you sure you want to delete this video?" %}</p>
            <form action="{% url 'wagtailvideos:delete' video.id %}" method="POST">
                {% csrf_token %}
                <input type="submit" class="button serious" value="{% trans 'Yes, delete' %}" />
            </form>
        </div>
    </div>
{% endblock %}

wagtailvideos/templates/wagtailvideos/videos/edit.html
{% extends "wagtailadmin/base.html" %}

{% load static wagtailadmin_tags i18n wagtailvideos_tags %}

{% block titletag %}{% blocktrans with title=video.title %}Editing video {{ title }}{% endblocktrans %}{% endblock %}

{% block extra_css %}
{{ block.super }}
<link rel="stylesheet" href="{% static 'wagtailvideos/css/edit-video.css' %}" type="text/css" /> {% endblock %}

{% block extra_js %}
{{ block.super }}
{% url 'wagtailadmin_tag_autocomplete' as autocomplete_url %}
<script>
    {{ form.media.css }}
    $(function() {
        $('#id_tags').tagit({
            autocomplete: {
                source: "{{ autocomplete_url|addslashes }}"
            }
        });
    });
</script>
{% endblock %}
{% block content %}
{% trans "Editing" as editing_str %}

{% include "wagtailadmin/shared/header.html" with title=editing_str subtitle=video.title icon="media" %}

<div class="row row-flush nice-padding">
    <div class="col6">
        <form action="{% url 'wagtailvideos:edit' video.id %}" method="POST" enctype="multipart/form-data">
            {% csrf_token %}
            <ul class="fields">
                {% for field in form %}
                  {% if field.name == 'file' %}
                    {% include "wagtailvideos/videos/_file_field_as_li.html"  with li_classes="label-above label-uppercase" %}
                  {% elif field.is_hidden %}
                    {{ field }}
                  {% else %}
                    {% include "wagtailadmin/shared/field_as_li.html" with li_classes="label-above label-uppercase" %}
                  {% endif %}
                {% endfor %}
                <li>
                    <input type="submit" class="button" value="{% trans 'Save' %}" />
                    {% if user_can_delete %}
                        <a href="{% url 'wagtailvideos:delete' video.id %}" class="button button-secondary no">{% trans "Delete video" %}</a>
                    {% endif %}
                </li>
            </ul>
        </form>
    </div>
    <div class="col6">
        <div class="row">
            <div class="col10 divider-after">
                {% video video controls style=max-width:100%;width:100%;height:auto; %}
            </div>
            <div class="col2">
                <dl style="margin-top: 0;">
                    {% if video.thumbnail %}
                    <dt>{% trans "Thumbnail" %}</dt>
                    <dd><img src="{{ video.thumbnail.url }}" alt="{% trans 'Video thumbnail' %}" /></dd>
                    {% endif %}
                    <dt>{% trans "Filesize" %}</dt>
                    <dd>{% if filesize %}{{ filesize|filesizeformat }}{% else %}{% trans "File not found" %}{% endif %}</dd>
                    {% if video.duration %}
                    <dt>{% trans "Duration" %}</dt>
                    <dd>{{ video.formatted_duration }}</dd>
                    {% endif %}
                    {% usage_count_enabled as uc_enabled %}
                    {% if uc_enabled %}
                        <dt>{% trans "Usage" %}</dt>
                        <dd>
                            <a href="{{ video.usage_url }}">{% blocktrans count usage_count=video.get_usage.count %}Used {{ usage_count }} time{% plural %}Used {{ usage_count }} times{% endblocktrans %}</a>
                        </dd>
                    {% endif %}
                </dl>
            </div>
        </div>
        <div class="row" style="margin-top: 2em;">
        {% if can_transcode %}
            <h2 class="u-text-transform-uppercase">{% trans "Transcodes" %}</h2>
            <p>{% trans "If you wish to generate HTML5 compliant transcodes use the form below. This may take a while depending on the length of the video." %}</p>
            {% if transcodes %}
            <h3 class="u-text-transform-uppercase">{% trans "Available Transcodes" %}</h3>
            <ul>
                {% for transcode in transcodes %}
                <li>
                    {% blocktrans with media_format=transcode.media_format quality=transcode.quality %}{{ media_format }} ({{ quality }} quality){% endblocktrans %}
                    {% if transcode.processing %}
                        <span class="processing">{% trans "(Processing... hold tight)" %} </span>
                    {% endif %}
                    {% if transcode.error_message %}
                        <span class="transcode-error">{% trans "ERROR:" %}</span>
                        <div class="transcode-error">
                            <pre> {{ transcode.error_message }}</pre>
                        </div>
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
            {% endif %}
            <h3 class="u-text-transform-uppercase">{% trans "Create transcode" %}</h3>
            <form action="{% url 'wagtailvideos:create_transcode' video.id %}" method="POST">
                <ul class="fields">
                    {% csrf_token %}
                    {% include "wagtailadmin/shared/field_as_li.html" with field=transcode_form.media_format li_classes="label-above label-uppercase" %}
                    {% include "wagtailadmin/shared/field_as_li.html" with field=transcode_form.quality li_classes="label-above label-uppercase" %}
                    <li>
                        <input class="button" type="submit" value="{% trans 'Start' %}" />
                    </li>
                </ul>
            </form>
        {% else %}
            <br/><br/>
            <span class="transcode-error">{% trans "Ffmpeg is not found on your server or you have disabled transcodes. Please install Ffmepg and make sure that transcoding is enabled if you wish to transcode videos into an HTML5 video compliant format." %}</span>
        {% endif %}
        {% if tracks_action_url %}
            <h2 class="u-text-transform-uppercase">{% trans "Tracks" %}</h2>
            <p>{% trans 'You can add/edit subtitles or accessibility captions for this video. For information about the filetype that should be used see the mozilla docs on <a href="https://developer.mozilla.org/en-US/docs/Web/API/WebVTT_API">WebVTT</a>' %}</p>
                {% if video.track_listing %}
                <ul>
                {% for track in video.track_listing.tracks.all %}
                    <li>{{ track }}</li>
                {% endfor %}
                </ul>
                <a class="button" href="{{ tracks_action_url }}">{% trans "Edit" %}</a>
                {% else %}
                <a class="button" href="{{ tracks_action_url }}">{% trans "Add tracks" %}</a>
                {% endif %}
        {% endif %}
        </div>
    </div>
</div>
{% endblock %}

wagtailvideos/templates/wagtailvideos/videos/index.html
{% extends "wagtailadmin/base.html" %}
{% load i18n %}

{% block titletag %}{% trans "Videos" %}{% endblock %}
{% block extra_js %}
    {{ block.super }}
    <script>
        window.headerSearch = {
            url: "{% url 'wagtailvideos:index' %}",
            termInput: "#id_q",
            targetOutput: "#video-results"
        }

        $(function() {
            $('#collection_chooser_collection_id').change(function() {
                this.form.submit();
            })
        });
    </script>
{% endblock %}

{% block content %}
    {% trans "Videos" as video_str %}

    {% trans "Add a video" as add_video_str %}
    {% url "wagtailvideos:add_multiple" as add_link %}
    {% include "wagtailadmin/shared/header.html" with title=video_str add_link="wagtailvideos:add_multiple" action_url=add_link icon="media" add_text=add_video_str action_text=add_video_str search_url="wagtailvideos:index" %}

    <div class="nice-padding">
        {% if collections %}
            <form class="image-search search-bar" action="{% url 'wagtailvideos:index' %}" method="GET">
                <ul class="fields">
                    {% include "wagtailadmin/shared/collection_chooser.html" %}
                </ul>
            </form>
        {% endif %}

        <div id="image-results">
            {% include "wagtailvideos/videos/results.html" %}
        </div>
    </div>

{% endblock %}

wagtailvideos/templates/wagtailvideos/videos/results.html
{% load wagtailadmin_tags %}
{% load i18n %}
{% if videos %}
    {% if is_searching %}
        <h2>
        {% blocktrans count counter=videos.paginator.count %}
            There is one match
        {% plural %}
            There are {{ counter }} matches
        {% endblocktrans %}
        </h2>

        {% search_other %}
    {% else %}
        <h2>{% trans "Latest videos" %}</h2>
    {% endif %}

    <ul class="listing horiz images">
        {% for video in videos %}
            <li>
                <a class="image-choice" href="{% url 'wagtailvideos:edit' video.id %}">
                    <div class="image">
                        {% if video.thumbnail %}
                        <img src="{{ video.thumbnail.url }}" height="165" width="165" class="show-transparency" alt="{% trans 'Video thumbnail' %}"/>
                        {% endif %}
                    </div>
                    <h3>{{ video.title|ellipsistrim:60 }}</h3>
                </a>
            </li>
        {% endfor %}
    </ul>

    {% include "wagtailadmin/shared/pagination_nav.html" with items=videos is_searching=is_searching query_string=query_string linkurl="wagtailvideos:index" %}

{% else %}
    {% if is_searching %}
        <h2>{% blocktrans %}Sorry, no videos match "<em>{{ query_string }}</em>"{% endblocktrans %}</h2>

        {% search_other %}
    {% else %}
        {% url 'wagtailvideos:add_multiple' as wagtailvideos_add_video_url %}
        {% if current_collection %}
            <p>{% blocktrans %}You've not uploaded any videos in this collection. Why not <a href="{{ wagtailvideos_add_video_url }}">add one now</a>?{% endblocktrans %}</p>
        {% else %}
            <p>{% blocktrans %}You've not uploaded any videos. Why not <a href="{{ wagtailvideos_add_video_url }}">add one now</a>?{% endblocktrans %}</p>
        {% endif %}
    {% endif %}
{% endif %}

wagtailvideos/templates/wagtailvideos/videos/usage.html
{% extends "wagtailadmin/base.html" %}
{% load i18n %}
{% block titletag %}{% blocktrans with title=video.title %}Usage of {{ title }}{% endblocktrans %}{% endblock %}
{% block content %}
    {% trans "Usage of" as usage_str %}
    {% include "wagtailadmin/shared/header.html" with title=usage_str subtitle=video.title %}

    <div class="nice-padding">
        <table class="listing">
            <col />
            <col width="30%"/>
            <col width="15%"/>
            <col width="15%"/>
            <thead>
                <tr>
                    <th class="title">{% trans "Title" %}</th>
                    <th>{% trans "Parent" %}</th>
                    <th>{% trans "Type" %}</th>
                    <th>{% trans "Status" %}</th>
                </tr>
            </thead>
            <tbody>
                {% for page in used_by %}
                    <tr>
                        <td class="title" valign="top">
                            <h2><a href="{% url 'wagtailadmin_pages:edit' page.id %}" title="{% trans 'Edit this page' %}">{{ page.title }}</a></h2>
                        </td>
                        <td>
                            {% if page.get_parent %}
                                <a href="{% url 'wagtailadmin_explore' page.get_parent.id %}">{{ page.get_parent.title }}</a>
                            {% endif %}
                        </td>
                        <td>
                            {{ page.content_type.model_class.get_verbose_name }}
                        </td>
                        <td>
                            {% include "wagtailadmin/shared/page_status_tag.html" with page=page %}
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
    {% include "wagtailadmin/shared/pagination_nav.html" with items=used_by linkurl="-" %}
{% endblock %}